Scriptname ABBA_ClockRefScript extends ReferenceAlias  

ABBA_Target Property Target auto
ABBA_Messages Property ABBAMsg Auto
ABBA_MainScript Property ABBAMain auto
ABBA_Morph Property Morph Auto
ABBA_ScanQuest Property ABBAScan Auto
ABBA_Script_MCM Property ABBAConfig Auto
ABBA_SL_Monitor Property SLMon Auto
ABBA_MorphMgr Property mMger Auto
ABBAShoutLearn Property ShoutScript Auto

Actor property PlayerRef Auto
float Property	PollSlider = 60.0 auto hidden
faction property AnimatingFaction auto
int property MaxNPCNumber = 20 auto ; Max Number of NPC to affect
bool property acrInflateNPC = false Auto hidden
bool property acrPlResize = true Auto hidden
bool property acrIncremental = false Auto hidden
bool property bKeepUpdating = true Auto hidden

; NiOverride version data
int Property NIOVERRIDE_VERSION = 1 AutoReadOnly hidden
int Property NIOVERRIDE_SCRIPT_VERSION = 2 AutoReadOnly hidden

Event OnInit()
	OnPlayerLoadGame()
EndEvent

Event OnPlayerLoadGame()
	ApplySettings()
	if Morph.bUseRngValues && !Morph.bRngGenerated
		Morph.bRngGenerated = true
		Morph.GetRandomValues(false)
	endif		
EndEvent

Function ApplySettings()
	Utility.wait(2.0) ;let mcm do it's thing
	if  CheckNiOverride()
		ABBAConfig.JsonCheck()
		Target.RegisterForCrosshairRef()
		ABBAMain.RegisterForKey(ABBAMain._myABBAKey)
		ABBAMain.RegisterForKey(ABBAMain._myABBARngKey)		
		if 	bKeepUpdating
			RegisterForSingleUpdate(10)
		EndIf
		if (Game.GetModbyName("ABBA-outfit.esp") != 255)
				ABBAMain.AbbaOutfit = true
				Morph.AbbaOutfit = true
				ABBAMain.EroticAura = Game.GetFormFromFile(0xFAAE, "ABBA-Outfit.esp") as MagicEffect	
				ABBAMain.MysteriousAura = Game.GetFormFromFile(0xBA0A, "ABBA-Outfit.esp") as MagicEffect
				ABBAMain.LewdAura = Game.GetFormFromFile(0x19C9F, "ABBA-Outfit.esp") as MagicEffect
				ABBAMain.ExoticAura = Game.GetFormFromFile(0x5F4F6, "ABBA-Outfit.esp") as MagicEffect
			else 
				ABBAMain.AbbaOutfit = false
				Morph.AbbaOutfit = false				
				ABBAMain.EroticAura = none	
				ABBAMain.MysteriousAura = none
				ABBAMain.LewdAura = none
				ABBAMain.ExoticAura = none
		endif
		if 	(Game.GetModbyName("SexLab Inflation Framework.esp") != 255)
				Morph.SlifEnabled = true
			else 
				Morph.SlifEnabled = false
		endif
		ABBAMain.SetSlotMasks()
		Morph.SetMyMorphV()
		Morph.SetMyMorphStrings()
		SLMon.RegModEvents()
		mMger.RegModEvents()
		If (!ShoutScript.Word3Learned) && (PlayerRef.GetLeveledActorBase().GetSex() == 1)
			ShoutScript.RegisterForTrackedStatsEvent()
		EndIf		
	else
		Debug.MessageBox("ABBA: SKSE plugin check failed. Please check your versions of SKSE, PapyrusUtil (version 33+) and Racemenu are compatible.\n Racemenu version " + SKSE.GetPluginVersion("skee") + " detected. \n PapyrusUtil version " + papyrusutil.GetVersion() + " detected.")
	Endif
EndFunction

Bool Function CheckNiOverride()
	Return SKSE.GetPluginVersion("nioverride") >= NIOVERRIDE_VERSION && NiOverride.GetScriptVersion() >= NIOVERRIDE_SCRIPT_VERSION
EndFunction

Event OnUpdate()
	ProcessABBAActors()
EndEvent

Function ProcessABBAActors()
	If (bKeepUpdating)
		if (acrPlResize && !PlayerRef.IsInFaction(AnimatingFaction) && !mMger.bTDFCheck(PlayerRef))
			ABBAMain.ABBAResize(PlayerRef, 0)
		endif
		if (acrInflateNPC)
			ABBAScan.Reset()
			ABBAScan.Stop()
            ABBAScan.Start()
			Utility.Wait(1.0)
			int NPC_Count = ABBAScan.getAbbaActors()
			Actor[] AbbaActors = ABBAScan.AbbaActors
			int i = 0           
				while(i < NPC_Count && i < MaxNPCNumber)
					if(AbbaActors[i] && !AbbaActors[i].IsInFaction(AnimatingFaction))						
						Cell NPCCell = AbbaActors[i].GetParentCell()						
						if	checkCell(NPCCell) && !mMger.bTDFCheck(AbbaActors[i])
							ABBAMain.ABBAResize(AbbaActors[i], 0)
						EndIf	
					Endif	
					i+= 1
				endwhile
		endif
		RegisterForSingleUpdate(PollSlider)
	EndIf
EndFunction

Bool Function checkCell(Cell ACell)
	if ACell == PlayerRef.GetParentCell()
		return true
	else
		return false
	endif
EndFunction
