Scriptname ABBA_MorphMgr extends Quest 

ABBA_Morph Property Morph auto
Bool Property bLogging = false Auto Hidden
Bool Property bSkipTDF = false Auto Hidden 
Bool Property bBuilt = false Auto Hidden 
int[] ABBA_TDFThreads

Bool _Locked = false
Bool bDancing = false

Float[] fIndex1
Float[] fIndex2
Actor[] aIndex1
Bool[] bIndex1
Bool[] bIndex2
Bool[] bIndex3
Bool[] bIndex4

Float[] fMorphIndex1
Float[] fMorphIndex2
Actor[] aMorphIndex1
Bool[] bMorphIndex1
Bool[] bMorphIndex2
Bool[] bMorphIndex3
Bool[] bMorphIndex4

Event OnInit()
	RegModEvents()
EndEvent

Event OnUpdate()
	if _Locked
		RegisterForSingleUpdate(0.5)
		return
	EndIf	
	ExecuteMorphs()
EndEvent

Function MgrLog(String Log)
	debug.Notification(log)
EndFunction	
	

Function RegModEvents()
	if !bBuilt
		aIndex1 = new Actor[30]
		fIndex1 = new Float[30]
		fIndex2 = new Float[30]
		bIndex1 = new Bool[30]
		bIndex2 = new Bool[30]
		bIndex3 = new Bool[30]
		bIndex4 = new Bool[30]
		aMorphIndex1 = new Actor[30]
		fMorphIndex1 = new Float[30]
		fMorphIndex2 = new Float[30]
		bMorphIndex1 = new Bool[30]
		bMorphIndex2 = new Bool[30]
		bMorphIndex3 = new Bool[30]
		bMorphIndex4 = new Bool[30]
		bBuilt = true
	EndIf
	if bSkipTDF
		RegisterForModEvent("TDFDanceEventBegin", "DancerModEventBegin")
		RegisterForModEvent("TDFDanceEventEnd", "DancerModEventEnd")
	EndIf
	RegisterForModEvent("ABBAMorphUpdate", "ABBAMorphEvent")
EndFunction

Function ExecuteMorphs()
	_Locked = true
	MergeValues()
	RemoveBaseValues()
	Utility.Wait(0.1)
	int m = ArrayCount(aMorphIndex1)
	if (m > 0)
		int i = 0
		While i < m
			Morph.DoinTheDo(fMorphIndex1[i], aMorphIndex1[i], fMorphIndex2[i], bMorphIndex1[i], bMorphIndex2[i], bMorphIndex3[i], bMorphIndex4[i])
			if bLogging
				string akName = aMorphIndex1[i].GetLeveledActorBase().GetName()
				int iArousal = (fMorphIndex1[i] * 100) as int
				MgrLog("ABBA Info: " + akName + " morphed to " + iArousal + "%")
			EndIf	
			i += 1
		EndWhile
	EndIf
	RemoveNewValues()
	_Locked = false
EndFunction

Function MergeValues()
	aMorphIndex1 = PapyrusUtil.MergeActorArray(aIndex1, aMorphIndex1, false);aIndex1
	fMorphIndex1 = PapyrusUtil.MergeFloatArray(fIndex1, fMorphIndex1, false);fIndex1	
	fMorphIndex2 = PapyrusUtil.MergeFloatArray(fIndex2, fMorphIndex2, false);fIndex2
	bMorphIndex1 = PapyrusUtil.MergeBoolArray(bIndex1, bMorphIndex1, false);bIndex1
	bMorphIndex2 = PapyrusUtil.MergeBoolArray(bIndex2, bMorphIndex2, false);bIndex2
	bMorphIndex3 = PapyrusUtil.MergeBoolArray(bIndex3, bMorphIndex3, false);bIndex3
	bMorphIndex4 = PapyrusUtil.MergeBoolArray(bIndex4, bMorphIndex4, false);bIndex3
EndFunction

Function RemoveBaseValues()
	aIndex1 = new Actor[30]
	fIndex1 = new Float[30]
	fIndex2 = new Float[30]
	bIndex1 = new Bool[30]
	bIndex2 = new Bool[30]
	bIndex3 = new Bool[30]
	bIndex4 = new Bool[30]	
EndFunction

Function RemoveNewValues()
	aMorphIndex1 = new Actor[30]
	fMorphIndex1 = new Float[30]
	fMorphIndex2 = new Float[30]
	bMorphIndex1 = new Bool[30]
	bMorphIndex2 = new Bool[30]
	bMorphIndex3 = new Bool[30]
	bMorphIndex4 = new Bool[30]		
EndFunction

Event ABBAMorphEvent(Float Arousal, Form fActor, Float Current, Bool bSlIncrements, Bool LewdButt, Bool CuirassWorn, Bool bAFOnly)
		Actor akActor = fActor as Actor
		if akActor
			int i = ArrayCount(aIndex1) 
			;Bool bActorNotInArray = (aIndex1.Find(akActor) == -1)
			if bTDFCheck(akActor) ;|| !bActorNotInArray 
				if bLogging
					string akName = akActor.GetLeveledActorBase().GetName()
					MgrLog("ABBA Info: morph skipped for " + akName)
				EndIf	
				return
			EndIf
			if i > 29
				if bLogging
					MgrLog("ABBA Info: morph stack too large skipping...")
				EndIf	
				return
			EndIf	
			aIndex1[i] = akActor 
			fIndex1[i] = Arousal
			fIndex2[i] = Current
			bIndex1[i] = bSlIncrements
			bIndex2[i] = LewdButt
			bIndex3[i] = CuirassWorn
			bIndex4[i] = bAFOnly
			RegisterForSingleUpdate(0.5)
		EndIf
EndEvent

int function ArrayCount(Actor[] myArray)
;Counts the number of indices in this array that do not have a "none" type.
	int i = 0
	int myCount = 0
	while i < myArray.Length
		if myArray[i] != none
			myCount += 1
			i += 1
		else
			i += 1
		endif
	endWhile
	return myCount
endFunction

Bool Function bTDFCheck(Actor akActor)
	if !bDancing
		return false
	EndIf	
	if bSkipTDF && ABBA_TDFThreads.Length > 0
		Form fActor = akActor as Form
		int i = 0
		While i < ABBA_TDFThreads.Length
			if (fActor == StorageUtil.GetFormValue(none, "ABBA_TDFDancerRef" + ABBA_TDFThreads[i]))
				return true
			EndIf	
			i += 1
		EndWhile
	EndIf
	return False
EndFunction

event DancerModEventBegin(int threadID, form ActorRef)
	StorageUtil.SetFormValue(none, "ABBA_TDFDancerRef" + threadID, ActorRef)
	ABBA_TDFThreads = PapyrusUtil.PushInt(ABBA_TDFThreads, threadID)
	bDancing = true
endevent

event DancerModEventEnd(int threadID)
	StorageUtil.UnSetFormValue(none, "ABBA_TDFDancerRef" + threadID)
	ABBA_TDFThreads = PapyrusUtil.RemoveInt(ABBA_TDFThreads, threadID)
	if ABBA_TDFThreads.Length < 1
		bDancing = false
	EndIf
endevent
