Scriptname ABBA_Morph_Util Hidden

Function SetABBAMorphValue(Actor akActor, float value, string MorphName, string ABBAMORPHS_KEY, bool SlifEnabled) Global
	If	!akActor.Is3DLoaded()
		return
	EndIf
	if SlifEnabled
		If value != 0.0
			ABBA_SLIF_morph(akActor, MorphName, value, ABBAMORPHS_KEY)
		Else
			ABBA_SLIF_unregisterMorph(akActor, MorphName)
		EndIf	
	else
		If value != 0.0
			NiOverride.SetBodyMorph(akActor, MorphName, ABBAMORPHS_KEY, value)
		Else
			NiOverride.SetBodyMorph(akActor, MorphName, ABBAMORPHS_KEY, value)
			NiOverride.ClearBodyMorph(akActor, MorphName, ABBAMORPHS_KEY)
		EndIf
	EndIf	
EndFunction

function UpdateABBAMorphs(Actor akActor) global
	If	!akActor.Is3DLoaded()
		return
	EndIf
	NiOverride.UpdateModelWeight(akActor)
endFunction

Function ABBA_SLIF_morph(Actor akActor, String MorphName, float value, string ABBAMORPHS_KEY) global
	int SLIF_event = ModEvent.Create("SLIF_morph")
	If SLIF_event
		ModEvent.PushForm(SLIF_event, akActor)
		ModEvent.PushString(SLIF_event, "ABBA")
		ModEvent.PushString(SLIF_event, MorphName)
		ModEvent.PushFloat(SLIF_event, value)
		ModEvent.PushString(SLIF_event, ABBAMORPHS_KEY)
		ModEvent.Send(SLIF_event)
	EndIf
EndFunction

Function ABBA_SLIF_unregisterMorph(Actor akActor, String MorphName) global
	int SLIF_event = ModEvent.Create("SLIF_unregisterMorph")
	If SLIF_event
		ModEvent.PushForm(SLIF_event, akActor)
		ModEvent.PushString(SLIF_event, "ABBA")
		ModEvent.PushString(SLIF_event, MorphName)
		ModEvent.Send(SLIF_event)
	EndIf
EndFunction
