Scriptname ABBA_SL_Monitor extends Quest

SexLabFramework Property SexLab Auto
ABBA_MainScript Property ABBAMain Auto
Actor Property PlayerRef Auto 
Keyword Property ActorTypeNPC Auto
bool property slInflateNPC = false Auto hidden
bool property slSexSquadAllowed = false Auto hidden
bool property slPlResize = true Auto hidden

Function RegModEvents()
	If slSexSquadAllowed && ABBAMain.bKeepUpdating
		RegisterForModEvent("HookStageStart", "SLStageStart")
		RegisterForModEvent("HookAnimationEnd", "SLAnimationEnd")
		RegisterForModEvent("SexLabOrgasmSeparate", "SlsoOrgasm")
		ABBAMain.RegisterForModEvent("ABBASlUpdate", "ABBASlEvent")
	Else
		UnRegisterForModEvent("HookStageStart")
		UnRegisterForModEvent("HookAnimationEnd")
		UnRegisterForModEvent("SexLabOrgasmSeparate")
		ABBAMain.UnRegisterForModEvent("ABBASlUpdate")
	EndIf
EndFunction

Event SLStageStart(int threadID, bool hasPlayer)
	if (!slSexSquadAllowed)
		return
	EndIf	
	SendSLEvent(threadID, 1)
EndEvent

event SLAnimationEnd(int threadID, bool hasPlayer)
	if (!slSexSquadAllowed)
		return
	EndIf	
	SendSLEvent(threadID, 3)
EndEvent

Event SlsoOrgasm(Form fActorRef, Int threadID)
	if !slSexSquadAllowed 
		return
	EndIf
	if fActorRef 
		Actor ActorRef = fActorRef as Actor
		if (ActorRef.GetLeveledActorBase().GetSex() == 0)
			return
		endif		
		if (ActorRef.HasKeyword(ActorTypeNPC) && (ActorRef != PlayerRef) && slInflateNPC && ActorRef.Is3dLoaded()) || (ActorRef == PlayerRef && slPlResize)
			ABBA_SL_Util.SendSLABBAEvent(ActorRef, 1.0, 2)
		EndIf	
	EndIf
EndEvent

Function SendSLEvent(int threadID, int iType)
	Actor[] SexSquad = SexLab.GetController(threadID).Positions
	If (SexSquad.length < 1)
		return
	EndIf
	int i = 0
	While i < SexSquad.length
		if(SexSquad[i]) ;make sure there is an actor
			if (SexSquad[i].GetLeveledActorBase().GetSex() != 0 && SexSquad[i].HasKeyword(ActorTypeNPC) && (SexSquad[i] != PlayerRef) && slInflateNPC && SexSquad[i].Is3dLoaded())
				ABBA_SL_Util.SendSLABBAEvent(SexSquad[i], 0.0, iType)
			elseIf ((SexSquad[i] == PlayerRef) && (PlayerRef.GetLeveledActorBase().GetSex() != 0) && slPlResize)
				if (iType == 3)
					ABBA_SL_Util.SendSLABBAEvent(SexSquad[i], 4.0, iType)
				else
					ABBA_SL_Util.SendSLABBAEvent(SexSquad[i], 0.0, iType)
				endif			
			EndIf	
		EndIf
		i += 1
	EndWhile
EndFunction

